## mingw-w64-gnuradio-3.10.11.0-9.src.tar.zst

=== gr-blocks/grc/CMakeLists.txt ===
# Copyright 2012-2013 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
file(GLOB yml_files "*.yml")

# Force out the controlport GRC blocks if we've disabled it.
if(NOT ENABLE_GR_CTRLPORT)
    list(REMOVE_ITEM yml_files ${CMAKE_CURRENT_SOURCE_DIR}/ctrlport_probe_c.block.yml
         ${CMAKE_CURRENT_SOURCE_DIR}/ctrlport_probe2_c.block.yml)
endif(NOT ENABLE_GR_CTRLPORT)

if(NOT SNDFILE_FOUND)
    list(REMOVE_ITEM yml_files ${CMAKE_CURRENT_SOURCE_DIR}/blocks_wavfile_sink.block.yml
         ${CMAKE_CURRENT_SOURCE_DIR}/blocks_wavfile_source.block.yml)
endif()

install(FILES ${yml_files} DESTINATION ${GRC_BLOCKS_DIR})

=== gr-channels/docs/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

install(FILES README.channels DESTINATION ${GR_PKG_DOC_DIR})

=== gr-channels/grc/CMakeLists.txt ===
# Copyright 2012-2013 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

file(GLOB yml_files "*.yml")
install(FILES ${yml_files} DESTINATION ${GRC_BLOCKS_DIR})

=== gr-soapy/lib/CMakeLists.txt ===
# Copyright 2011-2021 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-soapy
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup library
########################################################################
add_library(gnuradio-soapy block_impl.cc source_impl.cc sink_impl.cc)

target_compile_features(gnuradio-soapy PRIVATE ${GR_CXX_VERSION_FEATURE})

target_link_libraries(gnuradio-soapy PUBLIC gnuradio-runtime ${SoapySDR_LIBRARIES})

if(ENABLE_COMMON_PCH)
    target_link_libraries(gnuradio-soapy PRIVATE common-precompiled-headers)
endif()

target_include_directories(
    gnuradio-soapy PUBLIC $<INSTALL_INTERFACE:include>
                          $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

#Add Windows DLL resource file if using MSVC
if(MSVC)
    include(${PROJECT_SOURCE_DIR}/cmake/Modules/GrVersion.cmake)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-soapy.rc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-soapy.rc @ONLY)

    target_sources(gnuradio-soapy PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-soapy.rc)
endif(MSVC)

if(BUILD_SHARED_LIBS)
    gr_library_foo(gnuradio-soapy SoapySDR)
endif()

if(ENABLE_TESTING)
    include(GrTest)

    # If your unit tests require special include paths, add them here
    #include_directories()
    # List all files that contain Boost.UTF unit tests here
    list(APPEND test_soapy_sources)

    # Anything we need to link to for the unit tests go here
    list(APPEND GR_TEST_TARGET_DEPS gnuradio-soapy)

    if(NOT test_soapy_sources)
        message(STATUS "No C++ unit tests... skipping")
        return()
    endif(NOT test_soapy_sources)

    foreach(qa_file ${test_soapy_sources})
        gr_add_cpp_test("soapy_${qa_file}" ${CMAKE_CURRENT_SOURCE_DIR}/${qa_file})
    endforeach(qa_file)
endif()

=== gr-trellis/grc/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

install(
    FILES trellis_encoder_xx.block.yml
          trellis_siso_combined_f.block.yml
          trellis_viterbi_x.block.yml
          trellis_metrics_x.block.yml
          trellis_siso_f.block.yml
          trellis_permutation.block.yml
          trellis_viterbi_combined_xx.block.yml
          trellis_sccc_encoder_xx.block.yml
          trellis_sccc_decoder_x.block.yml
          trellis_sccc_decoder_combined_xx.block.yml
          trellis_pccc_encoder_xx.block.yml
          trellis_pccc_decoder_x.block.yml
          trellis_pccc_decoder_combined_xx.block.yml
    DESTINATION ${GRC_BLOCKS_DIR})

=== gr-zeromq/examples/CMakeLists.txt ===
# Copyright 2014 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

include(GrPython)

# Base stuff
INSTALL(FILES
    zeromq_pubsub.grc
    zeromq_pushpull.grc
    zeromq_reqrep.grc
    zmq_msg.grc
    zmq_stream.grc
    DESTINATION ${GR_PKG_ZEROMQ_EXAMPLES_DIR}
)

=== gr-utils/bindtool/templates/CMakeLists.txt ===
# Templates need to be placed in build directory for qa tests to work
file(
    COPY generic_python_cc.mako CMakeLists.txt.mako license.mako python_bindings_cc.mako
         pydoc_h.mako
         # types.py
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

install(
    FILES generic_python_cc.mako CMakeLists.txt.mako license.mako python_bindings_cc.mako
          pydoc_h.mako
          # types.py
    DESTINATION ${GR_PYTHON_DIR}/gnuradio/bindtool/templates)

=== gr-fec/python/fec/LDPC/CMakeLists.txt ===
# Copyright 2015 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

#####################################################################
include(GrPython)

gr_python_install(
    FILES __init__.py Generate_LDPC_matrix_functions.py Generate_LDPC_matrix.py
    DESTINATION ${GR_PYTHON_DIR}/gnuradio/fec/LDPC)

=== gr-qtgui/include/gnuradio/qtgui/CMakeLists.txt ===
# Copyright 2010-2012 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Install the header files
########################################################################
install(
    FILES api.h
          ConstellationDisplayPlot.h
          DisplayPlot.h
          EyeDisplayPlot.h
          FrequencyDisplayPlot.h
          HistogramDisplayPlot.h
          TimeDomainDisplayPlot.h
          TimeRasterDisplayPlot.h
          VectorDisplayPlot.h
          WaterfallDisplayPlot.h
          ber_sink_b.h
          const_sink_c.h
          constellationdisplayform.h
          displayform.h
          edit_box_msg.h
          eye_sink_c.h
          eye_sink_f.h
          eyecontrolpanel.h
          eyedisplayform.h
          eyedisplaysform.h
          form_menus.h
          freq_sink_c.h
          freq_sink_f.h
          freqcontrolpanel.h
          freqdisplayform.h
          histogram_sink_f.h
          histogramdisplayform.h
          number_sink.h
          numberdisplayform.h
          plot_raster.h
          plot_waterfall.h
          qtgui_types.h
          sink_c.h
          sink_f.h
          spectrumUpdateEvents.h
          timeRasterGlobalData.h
          time_raster_sink_b.h
          time_raster_sink_f.h
          time_sink_c.h
          time_sink_f.h
          timecontrolpanel.h
          timedisplayform.h
          timerasterdisplayform.h
          trigger_mode.h
          utils.h
          vector_sink_f.h
          vectordisplayform.h
          waterfallGlobalData.h
          waterfall_sink_c.h
          waterfall_sink_f.h
          waterfalldisplayform.h
    DESTINATION ${GR_INCLUDE_DIR}/gnuradio/qtgui)

=== gnuradio-runtime/python/gnuradio/gr/bindings/CMakeLists.txt ===
include(GrPybind)

########################################################################
# Python Bindings
########################################################################

list(
    APPEND
    gr_python_files
    messages/msg_accepter_msgq_python.cc
    messages/msg_accepter_python.cc
    messages/msg_passing_python.cc
    messages/msg_producer_python.cc
    messages/msg_queue_python.cc
    # attributes_python.cc
    basic_block_python.cc
    block_python.cc
    block_detail_python.cc
    block_gateway_python.cc
    # block_registry_python.cc
    buffer_python.cc
    buffer_reader_python.cc
    buffer_type_python.cc
    constants_python.cc
    dictionary_logger_backend_python.cc
    endianness_python.cc
    expj_python.cc
    flowgraph_python.cc
    fxpt_python.cc
    fxpt_nco_python.cc
    fxpt_vco_python.cc
    # gr_complex_python.cc
    hier_block2_python.cc
    high_res_timer_python.cc
    io_signature_python.cc
    logger_python.cc
    math_python.cc
    message_python.cc
    msg_accepter_python.cc
    # msg_accepter_msgq_python.cc
    # msg_passing_python.cc
    # msg_producer_python.cc
    msg_queue_python.cc
    # misc_python.cc
    msg_accepter_python.cc
    msg_handler_python.cc
    msg_queue_python.cc
    nco_python.cc
    pdu_python.cc
    prefs_python.cc
    # pycallback_object_python.cc
    random_python.cc
    realtime_python.cc
    runtime_types_python.cc
    sincos_python.cc
    sptr_magic_python.cc
    sync_block_python.cc
    sync_decimator_python.cc
    sync_interpolator_python.cc
    sys_paths_python.cc
    tagged_stream_block_python.cc
    tags_python.cc
    # thread_python.cc
    # thread_body_wrapper_python.cc
    # thread_group_python.cc
    top_block_python.cc
    tpb_detail_python.cc
    # types_python.cc
    # unittests_python.cc
    # xoroshiro128p_python.cc
    python_bindings.cc)

if(ENABLE_GR_CTRLPORT)
    list(APPEND gr_python_files 
        # rpcbufferedget_python.cc
        # rpcmanager_base_python.cc
        # rpcpmtconverters_thrift_python.cc
        # rpcregisterhelpers_python.cc
        # rpcserver_aggregator_python.cc
        # rpcserver_base_python.cc
        # rpcserver_booter_aggregator_python.cc
        # rpcserver_booter_thrift_python.cc
        # rpcserver_selector_python.cc
        # rpcserver_thrift_python.cc
        # thrift_application_base_python.cc
        # thrift_server_template_python.cc
        rpccallbackregister_base_python.cc
        rpcmanager_python.cc
        rpcserver_booter_base_python.cc
        )
endif()

gr_pybind_make_check_hash(gr ../../../.. gr::gr "${gr_python_files}")

if(ENABLE_GR_CTRLPORT)
    target_compile_definitions(gr_python PUBLIC GR_HAVE_CTRLPORT)
endif()

install(
    TARGETS gr_python
    DESTINATION ${GR_PYTHON_DIR}/gnuradio/gr
    COMPONENT pythonapi)

=== PKGBUILD ===
# Maintainer: Chris Gorman <chrisjohgorman@gmail.com>

_realname=gnuradio
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.10.11.0
pkgrel=9
pkgdesc="General purpose DSP and SDR toolkit (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url='https://gnuradio.org/'
msys2_repository_url="https://github.com/gnuradio/gnuradio"
msys2_references=(
  'archlinux: gnuradio'
)
license=(spdx:GPL-3.0-or-later)
depends=("${MINGW_PACKAGE_PREFIX}-codec2"
  "${MINGW_PACKAGE_PREFIX}-boost-libs"
  "${MINGW_PACKAGE_PREFIX}-gcc-libs"
  "${MINGW_PACKAGE_PREFIX}-gmp"
  "${MINGW_PACKAGE_PREFIX}-gsl"
  "${MINGW_PACKAGE_PREFIX}-gsm"
  "${MINGW_PACKAGE_PREFIX}-gtk3"
  "${MINGW_PACKAGE_PREFIX}-libad9361-iio"
  "${MINGW_PACKAGE_PREFIX}-libiio"
  "${MINGW_PACKAGE_PREFIX}-libuhd" 
  "${MINGW_PACKAGE_PREFIX}-libunwind"
  "${MINGW_PACKAGE_PREFIX}-fftw"
  "${MINGW_PACKAGE_PREFIX}-mathjax2"
  "${MINGW_PACKAGE_PREFIX}-volk"
  "${MINGW_PACKAGE_PREFIX}-python-click"
  "${MINGW_PACKAGE_PREFIX}-python-click-plugins"
  "${MINGW_PACKAGE_PREFIX}-python-gobject"
  "${MINGW_PACKAGE_PREFIX}-python-cairo"
  "${MINGW_PACKAGE_PREFIX}-python-jsonschema"
  "${MINGW_PACKAGE_PREFIX}-python-mako"
  "${MINGW_PACKAGE_PREFIX}-python-matplotlib"
  "${MINGW_PACKAGE_PREFIX}-python-numpy"
  "${MINGW_PACKAGE_PREFIX}-python-pygccxml"
  "${MINGW_PACKAGE_PREFIX}-python-pyaml" 
  "${MINGW_PACKAGE_PREFIX}-python-pyzmq"
  "${MINGW_PACKAGE_PREFIX}-python-scipy"
  "${MINGW_PACKAGE_PREFIX}-python-qtpy"
  "${MINGW_PACKAGE_PREFIX}-python-pyqt5"
  "${MINGW_PACKAGE_PREFIX}-python-pyqtgraph"
  "${MINGW_PACKAGE_PREFIX}-python-lxml"
  "${MINGW_PACKAGE_PREFIX}-python-pyopengl"
  "${MINGW_PACKAGE_PREFIX}-qt5-base"
  "${MINGW_PACKAGE_PREFIX}-angleproject"
  "${MINGW_PACKAGE_PREFIX}-qwt-qt5"
  "${MINGW_PACKAGE_PREFIX}-SDL"
  "${MINGW_PACKAGE_PREFIX}-soapysdr"
  "${MINGW_PACKAGE_PREFIX}-portaudio"
  "${MINGW_PACKAGE_PREFIX}-libsndfile"
  "${MINGW_PACKAGE_PREFIX}-spdlog"
  "${MINGW_PACKAGE_PREFIX}-fmt"
  "${MINGW_PACKAGE_PREFIX}-zeromq")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cppzmq"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-pybind11"
             "${MINGW_PACKAGE_PREFIX}-python-packaging"
             "${MINGW_PACKAGE_PREFIX}-python-pip")
checkdepends=("${MINGW_PACKAGE_PREFIX}-python-setuptools"
              "${MINGW_PACKAGE_PREFIX}-python-pytest")
optdepends=("${MINGW_PACKAGE_PREFIX}-soapyrtlsdr: install to use RTL-SDR devices with gnuradio")
options=('!strip')
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "https://github.com/gnuradio/gnuradio/releases/download/v${pkgver}/${_realname}-${pkgver}.tar.gz.asc"
        0001-cmake-Install-python-wrapper-exe-for-scripts-on-Wind.patch
        numpy-2.0.patch
        gnuradio-blocks-and-examples-path.hook.in
        gnuradio-blocks-and-examples-path.script.in
        LICENSE.txt)
validpgpkeys=(
  'B90DDFAC56989BF62262EB812987C77CBB8ED9B2'  # GNU Radio Project (Admin) <admin@gnuradio.org>
  'D74F9F146E7F755783583158B343B2BA293E5174'  # Marcus Müller (GNU Radio Maintainer) <mmueller@gnuradio.org>
  '723EC3A2B90533C6B93DFBC8ED797743F7951435'  # GNU Radio (Software Signing Key) <info@gnuradio.org>
)
sha256sums=('9ca658e6c4af9cfe144770757b34ab0edd23f6dcfaa6c5c46a7546233e5ecd29'
            'SKIP'
            'aa9c79f6ab923c566f57d90117fa7e82549c26230538ffb3a2b1c0246fc31c19'
            'e3a2d9f63318b56f87829d224232724d9c815b46c6c7086ac3c5b6ae8980bc7b'
            'b2f014a69b32afcb207e4d2e8e163fc04968594d7d4c3184b9ea5c8cf2a29329'
            'caa9a6cc253d508abcd01545f26b46df0d708d24f69b7dc59183d631872721ed'
            '86dc4bc79c9fa4d5dc3ae5558441d5bb8b8736403e70997cf9ae8f671ab5d0ca')
 
prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  # Patch number 0001 is credited to Ryan Volz <ryan.volz@gmail.com> and licensed under the 
  # BSD-3-Clause license
  patch -Np1 -i "${srcdir}/0001-cmake-Install-python-wrapper-exe-for-scripts-on-Wind.patch"
  patch -Np1 -i "${srcdir}/numpy-2.0.patch"
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  # FIXME remove -DENABLE_CTRLPORT_THRIFT=OFF when issue 7390 is fixed
  # https://github.com/gnuradio/gnuradio/issues/7390

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBoost_ATOMIC_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_atomic-mt.dll" \
      -DBoost_CHRONO_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_chrono-mt.dll" \
      -DBoost_DATE_TIME_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_date_time-mt.dll" \
      -DBoost_PROGRAM_OPTIONS_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_program_options-mt.dll" \
      -DBoost_REGEX_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_regex-mt.dll" \
      -DBoost_SYSTEM_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_system-mt.dll" \
      -DBoost_THREAD_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_thread-mt.dll" \
      -DBoost_UNIT_TEST_FRAMEWORK_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_unit_test_framework-mt.dll" \
      -DENABLE_CTRLPORT_THRIFT=OFF \
      -S "${_realname}-${pkgver}" \
      -DMATHJAX2_JS_PATH="${MINGW_PREFIX}/share/mathjax2" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

check() {
  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}" --target test || warning "Tests failed"
}

package() {

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  #install hook and script for setting global_blocks_path and examples_path in grc.conf
  hook_path=${srcdir}/${MINGW_PACKAGE_PREFIX}-gnuradio-blocks-and-examples-path.hook
  cp "${srcdir}/gnuradio-blocks-and-examples-path.hook.in" "${hook_path}"
  sed -s "s|@MINGW_PACKAGE_PREFIX@|${MINGW_PACKAGE_PREFIX}|g" -i "${hook_path}"
  install -Dt "$pkgdir/usr/share/libalpm/hooks" -m644 "${hook_path}"

  script_path="${srcdir}/${MINGW_PACKAGE_PREFIX}-gnuradio-blocks-and-examples-path.script";
  cp "${srcdir}/gnuradio-blocks-and-examples-path.script.in" "${script_path}"
  sed -s "s|@MINGW_PREFIX@|${MINGW_PREFIX}|g" -i "${script_path}"
  install -Dt "$pkgdir/usr/share/libalpm/scripts" -m755 "${script_path}"
 
  #install licenses
  install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
  install -Dm644 "${srcdir}/LICENSE.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.txt"
}
